import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * ӿ Ball Ÿ Ŭ̴.
 * MAX_SPEED Ball ִ ӵ Ÿ ̰
 * deltaX, deltaY  x, y ӵ̴.
 * count   ӵ ߱  ̴.
 * stuck Ball Paddle پ ִ θ Ÿ boolean ̴.
 */
public class Ball extends Actor
{
    private final int MAX_SPEED = 5;
    private int deltaX;         // x movement speed
    private int deltaY;         // y movement speed
    private int count = 2;
    private boolean stuck = true;   // stuck to paddle
    private Brick brick;
    
    /**
     * act ư   ݺǴ ޼̴.
     * Ball Paddle  ְ,   ʾ
     * move, makeSmoke, checkOut ޼带 Ų.
     */
    public void act() 
    {
        if (!stuck && !((Board) getWorld()).getCheck()) 
        {
            move();
            makeSmoke();
            checkOut();
        }
    }
    
    /**
     * Ball ̴ ޼̴.
     * ӵ  ġ Ű
     * checkPaddle, checkBrick, checkWalls ޼带 Ų.
     */
    private void move()
    {
        setLocation (getX() + deltaX, getY() + deltaY);
        checkPaddle();
        checkBrick();
        checkWalls();
    }
    
    /**
     * Ball Paddle ε ݻǴ ޼̴.
     *  ε y ӵ ݴ ٲٰ x ӵ Ѵ.
     */
    private void checkPaddle()
    {
        Actor paddle = getOneIntersectingObject(Paddle.class);
        if (paddle != null && getY() < paddle.getY()) {
            deltaY = -deltaY;
            int offset = getX() - paddle.getX();
            deltaX = deltaX + (offset/10);
            if (deltaX > MAX_SPEED) {
                deltaX = MAX_SPEED;
            }
            if (deltaX < -MAX_SPEED) {
                deltaX = -MAX_SPEED;
            }
        }            
    }
    
    /**
     * Ball Brick ε ݻǴ ޼̴.
     *  brick != null̸ εɷ Ѵ.
     */
    private void checkBrick()
    {
        brick = (Brick)getOneIntersectingObject(MetalBrick.class);
        if(brick==null){
            brick = (Brick)getOneIntersectingObject(NormalBrick.class);
        }
        
        if(brick != null){
            if(getY() > brick.getY()){
                setLocation(getX(),getY()+2);
                deltaY = -deltaY;
            }
            else if(getY() < brick.getY()){
                setLocation(getX(),getY()-2);
                deltaY = -deltaY;
            }
            else{
                deltaX = -(deltaX+1);
            }
            
            if(brick instanceof MetalBrick){
                Greenfoot.playSound("wav78.wav");
                MetalBrick metalBrick = (MetalBrick)brick;
                metalBrick.decreaseCount();
                if(metalBrick.isZero()){
                    metalBrick.remove();
                    ((Board) getWorld()).breakBrick();
                }
                else{
                    metalBrick.updateImage();
                }
            }
            if(brick instanceof NormalBrick){
                Greenfoot.playSound("wav78.wav");
                NormalBrick normalBrick = (NormalBrick)brick;
                normalBrick.decreaseCount();
                if(normalBrick.isZero()){
                    normalBrick.remove();
                    ((Board) getWorld()).breakBrick();
                }
            }
        }
    }
    
    /**
     * Ball Wall ε  ݻϴ ޼̴
     * , , ʿ ε ݻѴ.
     */
    private void checkWalls()
    {
        if (getX() == 0 || getX() == getWorld().getWidth()-1) {
            deltaX = -deltaX;
        }
        if (getY() == 0) {
            deltaY = -deltaY;
        }
    }
    
    /**
     * Ball ٴڿ Ҵ Ȯϴ ޼̴.
     *  ٴڿ  ballIsOut ޼带 ȣϰ
     * Ball Ѵ.
     */
    private void checkOut()
    {
        if (getY() == getWorld().getHeight()-1) {
            ((Board) getWorld()).ballIsOut();
            getWorld().removeObject(this);
        }
    }
    
    /**
     * Ball ,  ̴ ޼̴.
     */
    public void moveLR(int dist)
    {
        setLocation (getX() + dist, getY());
    }
    
    /**
     * Ball , Ʒ ̴ ޼̴.
     */
    public void moveUD(int dist)
    {
        setLocation (getX(), getY() + dist);
    }

    /**
     * Ball ο Smoke Ű ޼̴.
     * ʹ  Ǵ   
     * count  Ͽ ӵ .
     */
    private void makeSmoke()
    {
        count--;
        if (count == 0) {
            getWorld().addObject ( new Smoke(), getX(), getY());
            count = 2;
        }
    }
    
    /**
     * Ball ̱ ϰ ϴ ޼̴.
     * x ӵ -5~5    ϰ
     * y ӵ -MAX_SPEED Ѵ.
     * ׸ stuck false Ѵ.
     */
    public void release()
    {
        deltaX = Greenfoot.getRandomNumber(11) - 5;
        deltaY = -MAX_SPEED;
        stuck = false;
    }
}
